#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
@author: yungyu
"""
import puppy as p

class Test:
    """
    >>> t = Test()
    >>> t.fireCount(10) # it always triggers
    >>> t.fireReset()
    >>> t.fireWord("hello")
    hello
    >>> t.fireCount(2)
    hellohello
    >>> t.fireWord("world")
    world
    >>> t.update(2, "do them all!", False)
    do them all!do them all!
    """
    word = ""
    count = 1
    reset = False
    pupush result = p.foldAll(lambda x, y, z : "" if z else x * y, word, count, reset)
    pupush o1 = p.map(result, lambda x : print(x))

    def fireWord(self, n):
        self.word = n

    def fireCount(self, n):
        self.count = n

    def fireReset(self):
        self.reset = True
        self.count = 1
        self.word = ""
        self.reset = False

    def update(self, c, w, r):
        self.count = c
        self.word = w
        self.reset = r

if __name__ == "__main__":
    import doctest
    doctest.testmod()
